# Cloud Spanner V1 Client - Class ReadRequest (2.9.0)

2.9.0 (latest) 2.8.1 2.7.0 2.6.1 2.5.1 2.4.1 2.3.0 2.2.0 2.1.0 2.0.1-RC1 1.106.0 1.105.1 1.104.1 1.103.0 1.102.0 1.101.0 1.100.0 1.98.0 1.97.0 1.96.0 1.95.0 1.94.0 1.93.1 1.92.1 1.91.0 1.90.0 1.89.0 1.88.0 1.87.0 1.86.0 1.85.0 1.84.0 1.83.0 1.82.0 1.81.0 1.80.0 1.79.0 1.78.0 1.77.0 1.76.1 1.68.0 1.67.0 1.66.0 1.65.0 1.64.0 1.63.2 1.62.1 1.61.0 1.60.0 1.59.0 1.58.4 1.57.0 1.56.0 1.55.0 1.54.2 Reference documentation and code samples for the Cloud Spanner V1 Client class ReadRequest.

The request for [Read](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.Client.SpannerClient#_Google_Cloud_Spanner_V1_Client_SpannerClient__read__) and
[StreamingRead](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.Client.SpannerClient#_Google_Cloud_Spanner_V1_Client_SpannerClient__streamingRead__).

Generated from protobuf message `google.spanner.v1.ReadRequest`

## Namespace

Google \\ Cloud \\ Spanner \\ V1

## Methods

### __construct

Constructor.

| **Parameters** ||
|---|---|
| **Name** | **Description** |
| `data` | `array` Optional. Data for populating the Message object. |
| `↳ session` | `string` Required. The session in which the read should be performed. |
| `↳ transaction` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.TransactionSelector` The transaction to use. If none is provided, the default is a temporary read-only transaction with strong concurrency. |
| `↳ table` | `string` Required. The name of the table in the database to be read. |
| `↳ index` | `string` If non-empty, the name of an index on [table](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getTable__). This index is used instead of the table primary key when interpreting [key_set](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getKeySet__) and sorting result rows. See [key_set](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getKeySet__) for further information. |
| `↳ columns` | `string[]` Required. The columns of [table](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getTable__) to be returned for each row matching this request. |
| `↳ key_set` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.KeySet` Required. `key_set` identifies the rows to be yielded. `key_set` names the primary keys of the rows in [table](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getTable__) to be yielded, unless [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is present. If [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is present, then [key_set](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getKeySet__) instead names index keys in [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__). If the [partition_token](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getPartitionToken__) field is empty, rows are yielded in table primary key order (if [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is empty) or index key order (if [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is non-empty). If the [partition_token](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getPartitionToken__) field isn't empty, rows are yielded in an unspecified order. It isn't an error for the `key_set` to name rows that don't exist in the database. Read yields nothing for nonexistent rows. |
| `↳ limit` | `int|string` If greater than zero, only the first `limit` rows are yielded. If `limit` is zero, the default is no limit. A limit can't be specified if `partition_token` is set. |
| `↳ resume_token` | `string` If this request is resuming a previously interrupted read, `resume_token` should be copied from the last [PartialResultSet](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.PartialResultSet) yielded before the interruption. Doing this enables the new read to resume where the last read left off. The rest of the request parameters must exactly match the request that yielded this token. |
| `↳ partition_token` | `string` If present, results are restricted to the specified partition previously created using `PartitionRead`. There must be an exact match for the values of fields common to this message and the PartitionReadRequest message used to create this partition_token. |
| `↳ request_options` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.RequestOptions` Common options for this request. |
| `↳ directed_read_options` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.DirectedReadOptions` Directed read options for this request. |
| `↳ data_boost_enabled` | `bool` If this is for a partitioned read and this field is set to `true`, the request is executed with Spanner Data Boost independent compute resources. If the field is set to `true` but the request doesn't set `partition_token`, the API returns an `INVALID_ARGUMENT` error. |
| `↳ order_by` | `int` Optional. Order for the returned rows. By default, Spanner returns result rows in primary key order except for PartitionRead requests. For applications that don't require rows to be returned in primary key (`ORDER_BY_PRIMARY_KEY`) order, setting `ORDER_BY_NO_ORDER` option allows Spanner to optimize row retrieval, resulting in lower latencies in certain cases (for example, bulk point lookups). |
| `↳ lock_hint` | `int` Optional. Lock Hint for the request, it can only be used with read-write transactions. |
| `↳ routing_hint` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.RoutingHint` Optional. Makes the Spanner requests location-aware if present. It gives the server hints that can be used to route the request to an appropriate server, potentially significantly decreasing latency and improving throughput. To achieve improved performance, most fields must be filled in with accurate values. |

### getSession

Required. The session in which the read should be performed.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `string` |   |

### setSession

Required. The session in which the read should be performed.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `string` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getTransaction

The transaction to use. If none is provided, the default is a
temporary read-only transaction with strong concurrency.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.TransactionSelector|null` |   |

### hasTransaction

### clearTransaction

### setTransaction

The transaction to use. If none is provided, the default is a
temporary read-only transaction with strong concurrency.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.TransactionSelector` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getTable

Required. The name of the table in the database to be read.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `string` |   |

### setTable

Required. The name of the table in the database to be read.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `string` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getIndex

If non-empty, the name of an index on
[table](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getTable__). This index is used instead of
the table primary key when interpreting
[key_set](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getKeySet__) and sorting result rows.

See [key_set](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getKeySet__) for further
information.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `string` |   |

### setIndex

If non-empty, the name of an index on
[table](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getTable__). This index is used instead of
the table primary key when interpreting
[key_set](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getKeySet__) and sorting result rows.

See [key_set](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getKeySet__) for further
information.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `string` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getColumns

Required. The columns of [table](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getTable__) to be
returned for each row matching this request.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://protobuf.dev/reference/php/api-docs/Google/Protobuf/RepeatedField<string>` |   |

### setColumns

Required. The columns of [table](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getTable__) to be
returned for each row matching this request.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `string[]` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getKeySet

Required. `key_set` identifies the rows to be yielded. `key_set` names the
primary keys of the rows in [table](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getTable__) to
be yielded, unless [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is present.

If [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is present, then
[key_set](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getKeySet__) instead names index keys
in [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__).
If the [partition_token](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getPartitionToken__)
field is empty, rows are yielded in table primary key order (if
[index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is empty) or index key order
(if [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is non-empty). If the
[partition_token](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getPartitionToken__) field
isn't empty, rows are yielded in an unspecified order.
It isn't an error for the `key_set` to name rows that don't
exist in the database. Read yields nothing for nonexistent rows.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.KeySet|null` |   |

### hasKeySet

### clearKeySet

### setKeySet

Required. `key_set` identifies the rows to be yielded. `key_set` names the
primary keys of the rows in [table](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getTable__) to
be yielded, unless [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is present.

If [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is present, then
[key_set](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getKeySet__) instead names index keys
in [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__).
If the [partition_token](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getPartitionToken__)
field is empty, rows are yielded in table primary key order (if
[index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is empty) or index key order
(if [index](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getIndex__) is non-empty). If the
[partition_token](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest#_Google_Cloud_Spanner_V1_ReadRequest__getPartitionToken__) field
isn't empty, rows are yielded in an unspecified order.
It isn't an error for the `key_set` to name rows that don't
exist in the database. Read yields nothing for nonexistent rows.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.KeySet` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getLimit

If greater than zero, only the first `limit` rows are yielded. If `limit`
is zero, the default is no limit. A limit can't be specified if
`partition_token` is set.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `int|string` |   |

### setLimit

If greater than zero, only the first `limit` rows are yielded. If `limit`
is zero, the default is no limit. A limit can't be specified if
`partition_token` is set.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `int|string` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getResumeToken

If this request is resuming a previously interrupted read,
`resume_token` should be copied from the last
[PartialResultSet](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.PartialResultSet) yielded before the
interruption. Doing this enables the new read to resume where the last read
left off. The rest of the request parameters must exactly match the request
that yielded this token.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `string` |   |

### setResumeToken

If this request is resuming a previously interrupted read,
`resume_token` should be copied from the last
[PartialResultSet](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.PartialResultSet) yielded before the
interruption. Doing this enables the new read to resume where the last read
left off. The rest of the request parameters must exactly match the request
that yielded this token.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `string` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getPartitionToken

If present, results are restricted to the specified partition
previously created using `PartitionRead`. There must be an exact
match for the values of fields common to this message and the
PartitionReadRequest message used to create this partition_token.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `string` |   |

### setPartitionToken

If present, results are restricted to the specified partition
previously created using `PartitionRead`. There must be an exact
match for the values of fields common to this message and the
PartitionReadRequest message used to create this partition_token.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `string` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getRequestOptions

Common options for this request.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.RequestOptions|null` |   |

### hasRequestOptions

### clearRequestOptions

### setRequestOptions

Common options for this request.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.RequestOptions` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getDirectedReadOptions

Directed read options for this request.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.DirectedReadOptions|null` |   |

### hasDirectedReadOptions

### clearDirectedReadOptions

### setDirectedReadOptions

Directed read options for this request.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.DirectedReadOptions` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getDataBoostEnabled

If this is for a partitioned read and this field is set to `true`, the
request is executed with Spanner Data Boost independent compute resources.

If the field is set to `true` but the request doesn't set
`partition_token`, the API returns an `INVALID_ARGUMENT` error.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `bool` |   |

### setDataBoostEnabled

If this is for a partitioned read and this field is set to `true`, the
request is executed with Spanner Data Boost independent compute resources.

If the field is set to `true` but the request doesn't set
`partition_token`, the API returns an `INVALID_ARGUMENT` error.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `bool` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getOrderBy

Optional. Order for the returned rows.

By default, Spanner returns result rows in primary key order except for
PartitionRead requests. For applications that don't require rows to be
returned in primary key (`ORDER_BY_PRIMARY_KEY`) order, setting
`ORDER_BY_NO_ORDER` option allows Spanner to optimize row retrieval,
resulting in lower latencies in certain cases (for example, bulk point
lookups).

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `int` | Enum of type [OrderBy](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest.OrderBy). |

### setOrderBy

Optional. Order for the returned rows.

By default, Spanner returns result rows in primary key order except for
PartitionRead requests. For applications that don't require rows to be
returned in primary key (`ORDER_BY_PRIMARY_KEY`) order, setting
`ORDER_BY_NO_ORDER` option allows Spanner to optimize row retrieval,
resulting in lower latencies in certain cases (for example, bulk point
lookups).

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `int` Enum of type [OrderBy](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest.OrderBy). |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getLockHint

Optional. Lock Hint for the request, it can only be used with read-write
transactions.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `int` | Enum of type [LockHint](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest.LockHint). |

### setLockHint

Optional. Lock Hint for the request, it can only be used with read-write
transactions.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `int` Enum of type [LockHint](https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.ReadRequest.LockHint). |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |

### getRoutingHint

Optional. Makes the Spanner requests location-aware if present.

It gives the server hints that can be used to route the request
to an appropriate server, potentially significantly decreasing latency and
improving throughput. To achieve improved performance, most fields must be
filled in with accurate values.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.RoutingHint|null` |   |

### hasRoutingHint

### clearRoutingHint

### setRoutingHint

Optional. Makes the Spanner requests location-aware if present.

It gives the server hints that can be used to route the request
to an appropriate server, potentially significantly decreasing latency and
improving throughput. To achieve improved performance, most fields must be
filled in with accurate values.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `var` | `https://docs.cloud.google.com/php/docs/reference/cloud-spanner/latest/V1.RoutingHint` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `$this` |   |